var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: !0, configurable: !0, writable: !0, value }) : obj[key] = value;
var __name = (target, value) => __defProp(target, "name", { value, configurable: !0 });
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key != "symbol" ? key + "" : key, value);
import { useDependency, LocaleService, Inject, Disposable, UniverInstanceType, IUniverInstanceService, ILogService, ICommandService, Tools, LocaleType, CommandType, throttle, Injector, RxDisposable, connectInjector, DependentOn, Plugin, IConfigService } from "@univerjs/core";
import { SheetsSortService, SortType, SortRangeCommand, UniverSheetsSortPlugin } from "@univerjs/sheets-sort";
import { serializeRange } from "@univerjs/engine-formula";
import { getCurrentRangeDisable$, getCurrentExclusiveRangeInterest$, SheetsRenderService, SheetsUIPart } from "@univerjs/sheets-ui";
import { IConfirmService, MenuItemType, getMenuHiddenObservable, RibbonStartGroup, ContextMenuPosition, ContextMenuGroup, ComponentManager, IMenuManagerService, IDialogService, ILayoutService, IUIPartsService } from "@univerjs/ui";
import { BehaviorSubject, takeUntil } from "rxjs";
import { SheetsSelectionsService, getPrimaryForRange, SetSelectionsOperation, expandToContinuousRange, getSheetCommandTarget, WorkbookEditablePermission, WorksheetSortPermission, WorksheetEditPermission, RangeProtectionPermissionEditPoint } from "@univerjs/sheets";
import React, { forwardRef, useRef, createElement, useState, useCallback, useEffect } from "react";
import { RadioGroup, Radio, Checkbox, DraggableList, Button, Dropdown } from "@univerjs/design";
const PLUGIN_CONFIG_KEY = "sheets-sort-ui.config", defaultPluginConfig = {};
var __assign = function() {
  return __assign = Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) Object.prototype.hasOwnProperty.call(s, p) && (t[p] = s[p]);
    }
    return t;
  }, __assign.apply(this, arguments);
}, __rest = function(s, e) {
  var t = {};
  for (var p in s) Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0 && (t[p] = s[p]);
  if (s != null && typeof Object.getOwnPropertySymbols == "function")
    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++)
      e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]) && (t[p[i]] = s[p[i]]);
  return t;
}, IconBase = forwardRef(function(props, ref) {
  var icon = props.icon, id = props.id, className = props.className, extend = props.extend, restProps = __rest(props, ["icon", "id", "className", "extend"]), cls = "univerjs-icon univerjs-icon-".concat(id, " ").concat(className || "").trim(), idSuffix = useRef("_".concat(generateShortUuid()));
  return render(icon, "".concat(id), { defIds: icon.defIds, idSuffix: idSuffix.current }, __assign({ ref, className: cls }, restProps), extend);
});
function render(node, id, runtimeProps, rootProps, extend) {
  return createElement(node.tag, __assign(__assign({ key: id }, replaceRuntimeIdsAndExtInAttrs(node, runtimeProps, extend)), rootProps), (replaceRuntimeIdsInDefs(node, runtimeProps).children || []).map(function(child, index) {
    return render(child, "".concat(id, "-").concat(node.tag, "-").concat(index), runtimeProps, void 0, extend);
  }));
}
__name(render, "render");
function replaceRuntimeIdsAndExtInAttrs(node, runtimeProps, extend) {
  var attrs = __assign({}, node.attrs);
  extend != null && extend.colorChannel1 && attrs.fill === "colorChannel1" && (attrs.fill = extend.colorChannel1);
  var defIds = runtimeProps.defIds;
  return !defIds || defIds.length === 0 || (node.tag === "use" && attrs["xlink:href"] && (attrs["xlink:href"] = attrs["xlink:href"] + runtimeProps.idSuffix), Object.entries(attrs).forEach(function(_a4) {
    var key = _a4[0], value = _a4[1];
    typeof value == "string" && (attrs[key] = value.replace(/url\(#(.*)\)/, "url(#$1".concat(runtimeProps.idSuffix, ")")));
  })), attrs;
}
__name(replaceRuntimeIdsAndExtInAttrs, "replaceRuntimeIdsAndExtInAttrs");
function replaceRuntimeIdsInDefs(node, runtimeProps) {
  var _a4, defIds = runtimeProps.defIds;
  return !defIds || defIds.length === 0 ? node : node.tag === "defs" && (!((_a4 = node.children) === null || _a4 === void 0) && _a4.length) ? __assign(__assign({}, node), { children: node.children.map(function(child) {
    return typeof child.attrs.id == "string" && defIds && defIds.indexOf(child.attrs.id) > -1 ? __assign(__assign({}, child), { attrs: __assign(__assign({}, child.attrs), { id: child.attrs.id + runtimeProps.idSuffix }) }) : child;
  }) }) : node;
}
__name(replaceRuntimeIdsInDefs, "replaceRuntimeIdsInDefs");
function generateShortUuid() {
  return Math.random().toString(36).substring(2, 8);
}
__name(generateShortUuid, "generateShortUuid");
IconBase.displayName = "UniverIcon";
var element$9 = { tag: "svg", attrs: { fill: "none", viewBox: "0 0 16 16", width: "1em", height: "1em" }, children: [{ tag: "path", attrs: { fill: "currentColor", d: "M12.4208 14.4667C12.4208 14.798 12.1522 15.0667 11.8208 15.0667C11.4895 15.0667 11.2208 14.798 11.2208 14.4667V2.98193L9.97861 4.22417C9.7443 4.45848 9.3644 4.45848 9.13008 4.22417C8.89577 3.98985 8.89577 3.60995 9.13008 3.37564L11.3967 1.10897C11.6311 0.874657 12.011 0.874657 12.2453 1.10897L14.5119 3.37564C14.7463 3.60995 14.7463 3.98985 14.5119 4.22417C14.2776 4.45848 13.8977 4.45848 13.6634 4.22417L12.4208 2.9816V14.4667Z" } }, { tag: "path", attrs: { fill: "currentColor", d: "M1.98967 10.2798C1.6583 10.2798 1.38967 10.0112 1.38967 9.67983 1.38967 9.34846 1.6583 9.07983 1.98967 9.07983H6.50138C6.74406 9.07983 6.96284 9.22602 7.05571 9.45022 7.14858 9.67443 7.09725 9.9325 6.92565 10.1041L3.43819 13.5916H6.50138C6.83276 13.5916 7.10138 13.8602 7.10138 14.1916 7.10138 14.5229 6.83276 14.7916 6.50138 14.7916H1.98967C1.74699 14.7916 1.52821 14.6454 1.43534 14.4212 1.34247 14.197 1.3938 13.9389 1.5654 13.7673L5.05286 10.2798H1.98967zM5.1846 1.86439C4.8641.989866 3.62725.989866 3.30674 1.86439L1.34882 7.20672C1.23479 7.51786 1.39458 7.86252 1.70571 7.97655 2.01684 8.09058 2.3615 7.93079 2.47553 7.61966L3.06159 6.02055 3.06338 6.02056H5.42975L6.01581 7.61966C6.12984 7.93079 6.4745 8.09058 6.78563 7.97655 7.09677 7.86252 7.25655 7.51786 7.14252 7.20672L5.1846 1.86439zM4.98996 4.82056L4.24567 2.78971 3.50138 4.82056H4.98996z", fillRule: "evenodd", clipRule: "evenodd" } }] }, AscendingSingle = forwardRef(function(props, ref) {
  return createElement(IconBase, Object.assign({}, props, {
    id: "ascending- single",
    ref,
    icon: element$9
  }));
});
AscendingSingle.displayName = "AscendingSingle";
var element$8 = { tag: "svg", attrs: { fill: "none", viewBox: "0 0 16 16", width: "1em", height: "1em" }, children: [{ tag: "path", attrs: { fill: "currentColor", d: "M14.1544 3.75557C14.3887 3.98988 14.3887 4.36978 14.1544 4.6041L6.51409 12.2444C6.40157 12.3569 6.24896 12.4201 6.08983 12.4201C5.9307 12.4201 5.77808 12.3569 5.66556 12.2444L1.84541 8.42425C1.6111 8.18993 1.6111 7.81003 1.84541 7.57572C2.07973 7.34141 2.45963 7.34141 2.69394 7.57572L6.08983 10.9716L13.3059 3.75557C13.5402 3.52126 13.9201 3.52126 14.1544 3.75557Z", fillRule: "evenodd", clipRule: "evenodd" } }] }, CheckMarkSingle = forwardRef(function(props, ref) {
  return createElement(IconBase, Object.assign({}, props, {
    id: "check-mark-single",
    ref,
    icon: element$8
  }));
});
CheckMarkSingle.displayName = "CheckMarkSingle";
var element$7 = { tag: "svg", attrs: { fill: "none", viewBox: "0 0 16 16", width: "1em", height: "1em" }, children: [{ tag: "path", attrs: { fill: "currentColor", d: "M9.77445 9.24306L9.77457 11.9573C9.77458 12.2887 9.50597 12.5574 9.17459 12.5574 8.84322 12.5574 8.57458 12.2888 8.57457 11.9574L8.57439 7.79509C8.57438 7.46372 8.84299 7.19508 9.17436 7.19507 9.3281 7.19493 9.48196 7.25351 9.59925 7.3708L11.3465 9.11808C11.5808 9.3524 11.5808 9.7323 11.3465 9.96661 11.1122 10.2009 10.7323 10.2009 10.498 9.96661L9.77445 9.24306zM6.22584 10.5094L6.22572 7.79514C6.22571 7.46377 6.49433 7.19513 6.8257 7.19512 7.15707 7.1951 7.42571 7.46372 7.42572 7.79509L7.4259 11.9574C7.42592 12.2888 7.1573 12.5574 6.82593 12.5574 6.67228 12.5575 6.51828 12.4989 6.40104 12.3817L4.65376 10.6344C4.41945 10.4001 4.41945 10.0202 4.65376 9.78588 4.88808 9.55156 5.26798 9.55156 5.50229 9.78588L6.22584 10.5094z" } }, { tag: "path", attrs: { fill: "currentColor", d: "M1.14014 3.73989C1.14014 2.30396 2.3042 1.13989 3.74014 1.13989H12.2601C13.6961 1.13989 14.8601 2.30395 14.8601 3.73989V12.2599C14.8601 13.6958 13.6961 14.8599 12.2601 14.8599H3.74014C2.3042 14.8599 1.14014 13.6958 1.14014 12.2599V3.73989ZM2.34014 5.86724V12.2599C2.34014 13.0331 2.96694 13.6599 3.74014 13.6599H12.2601C13.0333 13.6599 13.6601 13.0331 13.6601 12.2599V5.86724H2.34014ZM13.6601 4.66724H2.34014V3.73989C2.34014 2.9667 2.96694 2.33989 3.74014 2.33989H12.2601C13.0333 2.33989 13.6601 2.96669 13.6601 3.73989V4.66724Z", fillRule: "evenodd", clipRule: "evenodd" } }] }, CustomSortSingle = forwardRef(function(props, ref) {
  return createElement(IconBase, Object.assign({}, props, {
    id: "custom-sort-single",
    ref,
    icon: element$7
  }));
});
CustomSortSingle.displayName = "CustomSortSingle";
var element$6 = { tag: "svg", attrs: { fill: "none", viewBox: "0 0 16 16", width: "1em", height: "1em" }, children: [{ tag: "path", attrs: { fill: "currentColor", d: "M5.3313 1.4667C5.3313 1.13533 5.59993.866699 5.9313.866699H10.069C10.4004.866699 10.669 1.13533 10.669 1.4667 10.669 1.79807 10.4004 2.0667 10.069 2.0667H5.9313C5.59993 2.0667 5.3313 1.79807 5.3313 1.4667zM1.09985 3.64443C1.09985 3.31306 1.36848 3.04443 1.69985 3.04443H14.2999C14.6312 3.04443 14.8999 3.31306 14.8999 3.64443 14.8999 3.9758 14.6312 4.24443 14.2999 4.24443H1.69985C1.36848 4.24443 1.09985 3.9758 1.09985 3.64443z" } }, { tag: "path", attrs: { fill: "currentColor", d: "M4.75332 5.22217C3.86966 5.22217 3.15332 5.93851 3.15332 6.82217V13.1332C3.15332 14.2377 4.04875 15.1332 5.15332 15.1332H10.8465C11.9511 15.1332 12.8465 14.2377 12.8465 13.1331V6.82217C12.8465 5.93851 12.1302 5.22217 11.2465 5.22217H4.75332ZM4.35332 6.82217C4.35332 6.60125 4.53241 6.42217 4.75332 6.42217H11.2465C11.4674 6.42217 11.6465 6.60125 11.6465 6.82217V13.1331C11.6465 13.575 11.2884 13.9331 10.8465 13.9331H5.15332C4.71149 13.9331 4.35332 13.575 4.35332 13.1332V6.82217Z", fillRule: "evenodd", clipRule: "evenodd" } }] }, DeleteEmptySingle = forwardRef(function(props, ref) {
  return createElement(IconBase, Object.assign({}, props, {
    id: "delete-empty-single",
    ref,
    icon: element$6
  }));
});
DeleteEmptySingle.displayName = "DeleteEmptySingle";
var element$5 = { tag: "svg", attrs: { fill: "none", viewBox: "0 0 16 16", width: "1em", height: "1em" }, children: [{ tag: "path", attrs: { fill: "currentColor", d: "M12.4208 1.53335C12.4208 1.20198 12.1522 0.93335 11.8208 0.93335C11.4895 0.93335 11.2208 1.20198 11.2208 1.53335V13.0181L9.97861 11.7758C9.7443 11.5415 9.3644 11.5415 9.13008 11.7758C8.89577 12.0101 8.89577 12.39 9.13008 12.6244L11.3967 14.891C11.6311 15.1253 12.011 15.1253 12.2453 14.891L14.5119 12.6244C14.7463 12.39 14.7463 12.0101 14.5119 11.7758C14.2776 11.5415 13.8977 11.5415 13.6634 11.7758L12.4208 13.0184V1.53335Z" } }, { tag: "path", attrs: { fill: "currentColor", d: "M1.98967 10.2798C1.6583 10.2798 1.38967 10.0112 1.38967 9.67983 1.38967 9.34846 1.6583 9.07983 1.98967 9.07983H6.50138C6.74406 9.07983 6.96284 9.22602 7.05571 9.45022 7.14858 9.67443 7.09725 9.9325 6.92565 10.1041L3.43819 13.5916H6.50138C6.83276 13.5916 7.10138 13.8602 7.10138 14.1916 7.10138 14.5229 6.83276 14.7916 6.50138 14.7916H1.98967C1.74699 14.7916 1.52821 14.6454 1.43534 14.4212 1.34247 14.197 1.3938 13.9389 1.5654 13.7673L5.05286 10.2798H1.98967zM5.1846 1.86439C4.8641.989866 3.62725.989866 3.30674 1.86439L1.34882 7.20672C1.23479 7.51786 1.39458 7.86252 1.70571 7.97655 2.01684 8.09058 2.3615 7.93079 2.47553 7.61966L3.06159 6.02055 3.06338 6.02056H5.42975L6.01581 7.61966C6.12984 7.93079 6.4745 8.09058 6.78563 7.97655 7.09677 7.86252 7.25655 7.51786 7.14252 7.20672L5.1846 1.86439zM4.98996 4.82056L4.24567 2.78971 3.50138 4.82056H4.98996z", fillRule: "evenodd", clipRule: "evenodd" } }] }, DescendingSingle = forwardRef(function(props, ref) {
  return createElement(IconBase, Object.assign({}, props, {
    id: "descending-single",
    ref,
    icon: element$5
  }));
});
DescendingSingle.displayName = "DescendingSingle";
var element$4 = { tag: "svg", attrs: { fill: "none", viewBox: "0 0 16 16", width: "1em", height: "1em" }, children: [{ tag: "path", attrs: { fill: "currentColor", d: "M1.9064 3.20024C1.57503 3.20024 1.3064 2.93161 1.3064 2.60024C1.3064 2.26887 1.57503 2.00024 1.9064 2.00024H4.57306C4.90443 2.00024 5.17306 2.26887 5.17306 2.60024C5.17306 2.93161 4.90443 3.20024 4.57306 3.20024H1.9064ZM1.3064 6.19985C1.3064 6.53122 1.57503 6.79985 1.9064 6.79985H5.9064C6.23777 6.79985 6.5064 6.53122 6.5064 6.19985C6.5064 5.86848 6.23777 5.59985 5.9064 5.59985H1.9064C1.57503 5.59985 1.3064 5.86848 1.3064 6.19985ZM1.9064 10.3997C1.57503 10.3997 1.3064 10.1311 1.3064 9.79971C1.3064 9.46834 1.57503 9.19971 1.9064 9.19971H7.23973C7.5711 9.19971 7.83973 9.46834 7.83973 9.79971C7.83973 10.1311 7.5711 10.3997 7.23973 10.3997H1.9064ZM1.9064 13.9996C1.57503 13.9996 1.3064 13.7309 1.3064 13.3996C1.3064 13.0682 1.57503 12.7996 1.9064 12.7996H8.57306C8.90443 12.7996 9.17306 13.0682 9.17306 13.3996C9.17306 13.7309 8.90443 13.9996 8.57306 13.9996H1.9064Z", fillRule: "evenodd", clipRule: "evenodd" } }, { tag: "path", attrs: { fill: "currentColor", d: "M12.4267 14.2667C12.4267 14.5981 12.1581 14.8667 11.8267 14.8667C11.4953 14.8667 11.2267 14.5981 11.2267 14.2667V3.18198L9.98447 4.42422C9.75015 4.65853 9.37026 4.65853 9.13594 4.42422C8.90163 4.1899 8.90163 3.81 9.13594 3.57569L11.4026 1.30902C11.6369 1.07471 12.0168 1.07471 12.2511 1.30902L14.5178 3.57569C14.7521 3.81 14.7521 4.1899 14.5178 4.42422C14.2835 4.65853 13.9036 4.65853 13.6693 4.42422L12.4267 3.18165V14.2667Z" } }] }, ExpandAscendingSingle = forwardRef(function(props, ref) {
  return createElement(IconBase, Object.assign({}, props, {
    id: "expand-ascending-single",
    ref,
    icon: element$4
  }));
});
ExpandAscendingSingle.displayName = "ExpandAscendingSingle";
var element$3 = { tag: "svg", attrs: { fill: "none", viewBox: "0 0 16 16", width: "1em", height: "1em" }, children: [{ tag: "path", attrs: { fill: "currentColor", d: "M1.9064 12.7998C1.57503 12.7998 1.3064 13.0684 1.3064 13.3998C1.3064 13.7311 1.57503 13.9998 1.9064 13.9998H4.57306C4.90443 13.9998 5.17306 13.7311 5.17306 13.3998C5.17306 13.0684 4.90443 12.7998 4.57306 12.7998H1.9064ZM1.3064 9.80015C1.3064 9.46878 1.57503 9.20015 1.9064 9.20015H5.9064C6.23777 9.20015 6.5064 9.46878 6.5064 9.80015C6.5064 10.1315 6.23777 10.4001 5.9064 10.4001H1.9064C1.57503 10.4001 1.3064 10.1315 1.3064 9.80015ZM1.9064 5.60029C1.57503 5.60029 1.3064 5.86892 1.3064 6.20029C1.3064 6.53166 1.57503 6.80029 1.9064 6.80029H7.23973C7.5711 6.80029 7.83973 6.53166 7.83973 6.20029C7.83973 5.86892 7.5711 5.60029 7.23973 5.60029H1.9064ZM1.9064 2.00044C1.57503 2.00044 1.3064 2.26907 1.3064 2.60044C1.3064 2.93181 1.57503 3.20044 1.9064 3.20044H8.57306C8.90443 3.20044 9.17306 2.93181 9.17306 2.60044C9.17306 2.26907 8.90443 2.00044 8.57306 2.00044H1.9064Z", fillRule: "evenodd", clipRule: "evenodd" } }, { tag: "path", attrs: { fill: "currentColor", d: "M12.4267 1.7333C12.4267 1.40193 12.1581 1.1333 11.8267 1.1333C11.4953 1.1333 11.2267 1.40193 11.2267 1.7333V12.818L9.98447 11.5758C9.75015 11.3415 9.37026 11.3415 9.13594 11.5758C8.90163 11.8101 8.90163 12.19 9.13594 12.4243L11.4026 14.691C11.6369 14.9253 12.0168 14.9253 12.2511 14.691L14.5178 12.4243C14.7521 12.19 14.7521 11.8101 14.5178 11.5758C14.2835 11.3415 13.9036 11.3415 13.6693 11.5758L12.4267 12.8183V1.7333Z" } }] }, ExpandDescendingSingle = forwardRef(function(props, ref) {
  return createElement(IconBase, Object.assign({}, props, {
    id: "expand-descending-single",
    ref,
    icon: element$3
  }));
});
ExpandDescendingSingle.displayName = "ExpandDescendingSingle";
var element$2 = { tag: "svg", attrs: { fill: "none", viewBox: "0 0 16 16", width: "1em", height: "1em" }, children: [{ tag: "path", attrs: { fill: "currentColor", d: "M8.6 1.99991C8.60001 1.66854 8.33138 1.39991 8.00001 1.3999C7.66864 1.3999 7.40001 1.66853 7.4 1.9999L7.39996 7.3999H1.9999C1.66853 7.3999 1.3999 7.66853 1.3999 7.9999C1.3999 8.33127 1.66853 8.5999 1.9999 8.5999H7.39995L7.3999 13.9999C7.3999 14.3313 7.66853 14.5999 7.9999 14.5999C8.33127 14.5999 8.5999 14.3313 8.5999 13.9999L8.59995 8.5999H13.9999C14.3313 8.5999 14.5999 8.33127 14.5999 7.9999C14.5999 7.66853 14.3313 7.3999 13.9999 7.3999H8.59996L8.6 1.99991Z" } }] }, IncreaseSingle = forwardRef(function(props, ref) {
  return createElement(IconBase, Object.assign({}, props, {
    id: "increase-single",
    ref,
    icon: element$2
  }));
});
IncreaseSingle.displayName = "IncreaseSingle";
var element$1 = { tag: "svg", attrs: { fill: "none", viewBox: "0 0 16 16", width: "1em", height: "1em" }, children: [{ tag: "path", attrs: { fill: "currentColor", d: "M11.3536 6.14645C11.5488 6.34171 11.5488 6.65829 11.3536 6.85355L8.35355 9.85355C8.15829 10.0488 7.84171 10.0488 7.64645 9.85355L4.64645 6.85355C4.45118 6.65829 4.45118 6.34171 4.64645 6.14645C4.84171 5.95118 5.15829 5.95118 5.35355 6.14645L8 8.79289L10.6464 6.14645C10.8417 5.95118 11.1583 5.95118 11.3536 6.14645Z", fillRule: "evenodd", clipRule: "evenodd" } }] }, MoreDownSingle = forwardRef(function(props, ref) {
  return createElement(IconBase, Object.assign({}, props, {
    id: "more-down-single",
    ref,
    icon: element$1
  }));
});
MoreDownSingle.displayName = "MoreDownSingle";
var element = { tag: "svg", attrs: { fill: "none", viewBox: "0 0 16 16", width: "1em", height: "1em" }, children: [{ tag: "mask", attrs: { id: "mask0_622_8", style: { maskType: "alpha" }, width: 16, height: 16, x: 0, y: 0, maskUnits: "userSpaceOnUse" }, children: [{ tag: "path", attrs: { fill: "#D9D9D9", d: "M0 0H16V16H0z" } }] }, { tag: "g", attrs: { fill: "currentColor", mask: "url(#mask0_622_8)" }, children: [{ tag: "path", attrs: { d: "M6 5C6.55228 5 7 4.55228 7 4 7 3.44772 6.55228 3 6 3 5.44772 3 5 3.44772 5 4 5 4.55228 5.44772 5 6 5zM6 9C6.55228 9 7 8.55229 7 8 7 7.44772 6.55228 7 6 7 5.44772 7 5 7.44772 5 8 5 8.55229 5.44772 9 6 9zM7 12C7 12.5523 6.55228 13 6 13 5.44772 13 5 12.5523 5 12 5 11.4477 5.44772 11 6 11 6.55228 11 7 11.4477 7 12zM10 5C10.5523 5 11 4.55228 11 4 11 3.44772 10.5523 3 10 3 9.44771 3 9 3.44772 9 4 9 4.55228 9.44771 5 10 5zM11 8C11 8.55229 10.5523 9 10 9 9.44771 9 9 8.55229 9 8 9 7.44772 9.44771 7 10 7 10.5523 7 11 7.44772 11 8zM10 13C10.5523 13 11 12.5523 11 12 11 11.4477 10.5523 11 10 11 9.44771 11 9 11.4477 9 12 9 12.5523 9.44771 13 10 13z" } }] }] }, SequenceSingle = forwardRef(function(props, ref) {
  return createElement(IconBase, Object.assign({}, props, {
    id: "sequence-single",
    ref,
    icon: element
  }));
});
SequenceSingle.displayName = "SequenceSingle";
const extendConfirmContent = "univer-extend-confirm-content", extendConfirmRadioGroup = "univer-extend-confirm-radio-group", customSortPanelContainer = "univer-custom-sort-panel-container", customSortPanelExt = "univer-custom-sort-panel-ext", addCondition = "univer-add-condition", addConditionText = "univer-add-condition-text", addConditionDisable = "univer-add-condition-disable", customSortPanelFooter = "univer-custom-sort-panel-footer", customSortPanelFooterBtn = "univer-custom-sort-panel-footer-btn", customSortPanelItem = "univer-custom-sort-panel-item", customSortPanelItemHead = "univer-custom-sort-panel-item-head", customSortPanelItemHandler = "univer-custom-sort-panel-item-handler", customSortPanelItemRemove = "univer-custom-sort-panel-item-remove", customSortPanelItemColumnInput = "univer-custom-sort-panel-item-column-input", customSortPanelItemColumnInputDropdown = "univer-custom-sort-panel-item-column-input-dropdown", customSortPanelItemColumnInputText = "univer-custom-sort-panel-item-column-input-text", customSortPanelItemOrderRadio = "univer-custom-sort-panel-item-order-radio", customSortPanelItemOrderRadioCn = "univer-custom-sort-panel-item-order-radio-cn", conditionList = "univer-condition-list", embedSortBtnContainer = "univer-embed-sort-btn-container", embedSortBtn = "univer-embed-sort-btn", embedSortBtnAsc = "univer-embed-sort-btn-asc", embedSortBtnDesc = "univer-embed-sort-btn-desc", embedSortBtnIcon = "univer-embed-sort-btn-icon", customSortColMenu = "univer-custom-sort-col-menu", customSortColMenuItem = "univer-custom-sort-col-menu-item", customSortColMenuItemDesc = "univer-custom-sort-col-menu-item-desc", styles = {
  extendConfirmContent,
  extendConfirmRadioGroup,
  customSortPanelContainer,
  customSortPanelExt,
  addCondition,
  addConditionText,
  addConditionDisable,
  customSortPanelFooter,
  customSortPanelFooterBtn,
  customSortPanelItem,
  customSortPanelItemHead,
  customSortPanelItemHandler,
  customSortPanelItemRemove,
  customSortPanelItemColumnInput,
  customSortPanelItemColumnInputDropdown,
  customSortPanelItemColumnInputText,
  customSortPanelItemOrderRadio,
  customSortPanelItemOrderRadioCn,
  conditionList,
  embedSortBtnContainer,
  embedSortBtn,
  embedSortBtnAsc,
  embedSortBtnDesc,
  embedSortBtnIcon,
  customSortColMenu,
  customSortColMenuItem,
  customSortColMenuItemDesc
}, ExtendConfirm = /* @__PURE__ */ __name((props) => {
  const [extend, setExtend] = useState("0"), localeService = useDependency(LocaleService);
  return /* @__PURE__ */ React.createElement("div", { className: styles.extendConfirmContent }, /* @__PURE__ */ React.createElement("div", { className: "extend-confirm-desc" }, localeService.t("sheets-sort.dialog.sort-reminder-desc")), /* @__PURE__ */ React.createElement(
    RadioGroup,
    {
      className: styles.extendConfirmRadioGroup,
      value: extend,
      direction: "vertical",
      onChange: /* @__PURE__ */ __name((value) => {
        setExtend(value), props.onChange(value);
      }, "onChange")
    },
    /* @__PURE__ */ React.createElement(
      Radio,
      {
        value: "0"
      },
      localeService.t("sheets-sort.dialog.sort-reminder-no")
    ),
    /* @__PURE__ */ React.createElement(Radio, { value: "1" }, localeService.t("sheets-sort.dialog.sort-reminder-ext"))
  ));
}, "ExtendConfirm");
var __defProp$2 = Object.defineProperty, __getOwnPropDesc$2 = Object.getOwnPropertyDescriptor, __decorateClass$2 = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc$2(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp$2(target, key, result), result;
}, "__decorateClass$2"), __decorateParam$2 = /* @__PURE__ */ __name((index, decorator) => (target, key) => decorator(target, key, index), "__decorateParam$2");
const SORT_ERROR_MESSAGE = {
  MERGE_ERROR: "sheets-sort.error.merge-size",
  EMPTY_ERROR: "sheets-sort.error.empty",
  SINGLE_ERROR: "sheets-sort.error.single",
  FORMULA_ARRAY: "sheets-sort.error.formula-array"
};
var _a;
let SheetsSortUIService = (_a = class extends Disposable {
  constructor(_univerInstanceService, _confirmService, _logService, _selectionManagerService, _sheetsSortService, _localeService, _commandService) {
    super();
    __publicField(this, "_customSortState$", new BehaviorSubject(null));
    __publicField(this, "customSortState$", this._customSortState$.asObservable());
    this._univerInstanceService = _univerInstanceService, this._confirmService = _confirmService, this._logService = _logService, this._selectionManagerService = _selectionManagerService, this._sheetsSortService = _sheetsSortService, this._localeService = _localeService, this._commandService = _commandService;
  }
  async triggerSortDirectly(asc, extend, sheetRangeLocation) {
    const location = sheetRangeLocation || await this._detectSortLocation(extend);
    if (!location || !this._check(location))
      return !1;
    const sortOption = {
      orderRules: [{
        type: asc ? SortType.ASC : SortType.DESC,
        colIndex: location.colIndex
      }],
      range: location.range
    };
    return this._sheetsSortService.applySort(sortOption, location.unitId, location.subUnitId), !0;
  }
  async triggerSortCustomize() {
    const location = await this._detectSortLocation();
    return !location || !this._check(location) ? !1 : (this.showCustomSortPanel(location), !0);
  }
  customSortState() {
    return this._customSortState$.getValue();
  }
  getTitles(hasTitle) {
    var _a4, _b;
    const location = (_a4 = this.customSortState()) == null ? void 0 : _a4.location;
    if (!location)
      return [];
    const { unitId, subUnitId, range } = location, worksheet = (_b = this._univerInstanceService.getUnit(unitId)) == null ? void 0 : _b.getSheetBySheetId(subUnitId);
    if (!worksheet)
      return [];
    const colTranslator = colIndexTranslator(this._localeService);
    return Array.from(
      { length: range.endColumn - range.startColumn + 1 },
      (_, i) => {
        var _a5;
        const cellValue = (_a5 = worksheet.getCell(range.startRow, i + range.startColumn)) == null ? void 0 : _a5.v;
        return {
          index: i + range.startColumn,
          label: hasTitle ? `${cellValue != null ? cellValue : colTranslator(i + range.startColumn)}` : colTranslator(i + range.startColumn)
        };
      }
    );
  }
  setSelection(unitId, subUnitId, range) {
    var _a4;
    const worksheet = (_a4 = this._univerInstanceService.getUnit(unitId)) == null ? void 0 : _a4.getSheetBySheetId(subUnitId);
    if (!worksheet)
      return;
    const setSelectionsOperationParams = {
      unitId,
      subUnitId,
      selections: [{ range, primary: getPrimaryForRange(range, worksheet), style: null }]
    };
    this._commandService.executeCommand(SetSelectionsOperation.id, setSelectionsOperationParams);
  }
  async showCheckError(content) {
    return await this._confirmService.confirm({
      id: "sort-range-check-error",
      title: {
        title: this._localeService.t("info.tooltip")
      },
      children: {
        title: /* @__PURE__ */ React.createElement("div", null, this._localeService.t(content))
      }
    });
  }
  async showExtendConfirm() {
    let shouldExtend = !1;
    return await this._confirmService.confirm({
      id: "extend-sort-range-dialog",
      title: {
        title: this._localeService.t("sheets-sort.dialog.sort-reminder")
      },
      children: {
        title: /* @__PURE__ */ React.createElement(
          ExtendConfirm,
          {
            onChange: /* @__PURE__ */ __name((value) => {
              shouldExtend = value === "1";
            }, "onChange")
          }
        )
      },
      width: 400
    }) ? shouldExtend ? "extend" : "keep" : "cancel";
  }
  showCustomSortPanel(location) {
    this._customSortState$.next({ location, show: !0 });
  }
  closeCustomSortPanel() {
    this._customSortState$.next({ show: !1 });
  }
  _check(location) {
    return this._sheetsSortService.singleCheck(location) ? this._sheetsSortService.mergeCheck(location) ? this._sheetsSortService.formulaCheck(location) ? this._sheetsSortService.emptyCheck(location) ? !0 : (this.showCheckError(SORT_ERROR_MESSAGE.EMPTY_ERROR), !1) : (this.showCheckError(SORT_ERROR_MESSAGE.FORMULA_ARRAY), !1) : (this.showCheckError(SORT_ERROR_MESSAGE.MERGE_ERROR), !1) : (this.showCheckError(SORT_ERROR_MESSAGE.SINGLE_ERROR), !1);
  }
  async _detectSortLocation(extend) {
    const workbook = this._univerInstanceService.getCurrentUnitForType(UniverInstanceType.UNIVER_SHEET), worksheet = workbook.getActiveSheet(), unitId = workbook.getUnitId(), subUnitId = worksheet.getSheetId(), selection = this._selectionManagerService.getCurrentLastSelection();
    if (!selection)
      return null;
    let range;
    if (extend === !0)
      range = expandToContinuousRange(selection.range, { up: !0, down: !0, left: !0, right: !0 }, worksheet), this.setSelection(unitId, subUnitId, range);
    else if (extend === !1)
      range = selection.range;
    else {
      const confirmRes = await this.showExtendConfirm();
      if (confirmRes === "cancel")
        return null;
      confirmRes === "keep" ? range = selection.range : (range = expandToContinuousRange(selection.range, { up: !0, down: !0, left: !0, right: !0 }, worksheet), this.setSelection(unitId, subUnitId, range));
    }
    return {
      range,
      unitId,
      subUnitId,
      colIndex: selection.primary.actualColumn
    };
  }
}, __name(_a, "SheetsSortUIService"), _a);
SheetsSortUIService = __decorateClass$2([
  __decorateParam$2(0, IUniverInstanceService),
  __decorateParam$2(1, IConfirmService),
  __decorateParam$2(2, ILogService),
  __decorateParam$2(3, Inject(SheetsSelectionsService)),
  __decorateParam$2(4, Inject(SheetsSortService)),
  __decorateParam$2(5, Inject(LocaleService)),
  __decorateParam$2(6, ICommandService)
], SheetsSortUIService);
function colIndexTranslator(localeService) {
  return (colIndex) => {
    const colName = Tools.chatAtABC(colIndex);
    switch (localeService.getCurrentLocale()) {
      case LocaleType.ZH_CN:
        return `"${colName}"列`;
      case LocaleType.EN_US:
        return `Column "${colName}"`;
      default:
        return `Column "${colName}"`;
    }
  };
}
__name(colIndexTranslator, "colIndexTranslator");
const SortRangeAscCommand = {
  id: "sheet.command.sort-range-asc",
  type: CommandType.COMMAND,
  handler: /* @__PURE__ */ __name(async (accessor) => await accessor.get(SheetsSortUIService).triggerSortDirectly(!0, !1), "handler")
}, SortRangeAscExtCommand = {
  id: "sheet.command.sort-range-asc-ext",
  type: CommandType.COMMAND,
  handler: /* @__PURE__ */ __name(async (accessor) => await accessor.get(SheetsSortUIService).triggerSortDirectly(!0, !0), "handler")
}, SortRangeDescCommand = {
  id: "sheet.command.sort-range-desc",
  type: CommandType.COMMAND,
  handler: /* @__PURE__ */ __name(async (accessor) => await accessor.get(SheetsSortUIService).triggerSortDirectly(!1, !1), "handler")
}, SortRangeDescExtCommand = {
  id: "sheet.command.sort-range-desc-ext",
  type: CommandType.COMMAND,
  handler: /* @__PURE__ */ __name(async (accessor) => await accessor.get(SheetsSortUIService).triggerSortDirectly(!1, !0), "handler")
}, SortRangeCustomCommand = {
  id: "sheet.command.sort-range-custom",
  type: CommandType.COMMAND,
  handler: /* @__PURE__ */ __name(async (accessor) => await accessor.get(SheetsSortUIService).triggerSortCustomize(), "handler")
}, SortRangeAscInCtxMenuCommand = {
  id: "sheet.command.sort-range-asc-ctx",
  type: CommandType.COMMAND,
  handler: /* @__PURE__ */ __name(async (accessor) => await accessor.get(SheetsSortUIService).triggerSortDirectly(!0, !1), "handler")
}, SortRangeAscExtInCtxMenuCommand = {
  id: "sheet.command.sort-range-asc-ext-ctx",
  type: CommandType.COMMAND,
  handler: /* @__PURE__ */ __name(async (accessor) => await accessor.get(SheetsSortUIService).triggerSortDirectly(!0, !0), "handler")
}, SortRangeDescInCtxMenuCommand = {
  id: "sheet.command.sort-range-desc-ctx",
  type: CommandType.COMMAND,
  handler: /* @__PURE__ */ __name(async (accessor) => await accessor.get(SheetsSortUIService).triggerSortDirectly(!1, !1), "handler")
}, SortRangeDescExtInCtxMenuCommand = {
  id: "sheet.command.sort-range-desc-ext-ctx",
  type: CommandType.COMMAND,
  handler: /* @__PURE__ */ __name(async (accessor) => await accessor.get(SheetsSortUIService).triggerSortDirectly(!1, !0), "handler")
}, SortRangeCustomInCtxMenuCommand = {
  id: "sheet.command.sort-range-custom-ctx",
  type: CommandType.COMMAND,
  handler: /* @__PURE__ */ __name(async (accessor) => await accessor.get(SheetsSortUIService).triggerSortCustomize(), "handler")
};
function CustomSortPanel() {
  const sheetsSortUIService = useDependency(SheetsSortUIService), sheetsSortService = useDependency(SheetsSortService), localeService = useDependency(LocaleService), [hasTitle, setHasTitle] = useState(!1), [scrollPosition, setScrollPosition] = useState(0), listEndRef = useRef(null), state = sheetsSortUIService.customSortState();
  if (!state || !state.location)
    return null;
  const { range, unitId, subUnitId } = state.location, titles = sheetsSortUIService.getTitles(hasTitle), [list, setList] = useState([
    { type: SortType.ASC, colIndex: range.startColumn }
  ]), onItemChange = useCallback((index, value) => {
    const newList = [...list];
    value === null ? newList.splice(index, 1) : newList[index] = value, setList(newList);
  }, [list]), newItem = useCallback(
    throttle(() => {
      const newList = [...list], nextColIndex = findNextColIndex(range, list);
      nextColIndex !== null && (newList.push({ type: SortType.ASC, colIndex: nextColIndex }), setList(newList));
    }, 200),
    [list, range]
  ), apply = useCallback((orderRules, hasTitle2) => {
    sheetsSortService.applySort({ range, orderRules, hasTitle: hasTitle2 }), sheetsSortUIService.closeCustomSortPanel();
  }, [sheetsSortService, sheetsSortUIService, range]), cancel = useCallback(() => {
    sheetsSortUIService.closeCustomSortPanel();
  }, [sheetsSortUIService]), setTitle = useCallback((value) => {
    setHasTitle(value), value ? sheetsSortUIService.setSelection(unitId, subUnitId, { ...range, startRow: range.startRow + 1 }) : sheetsSortUIService.setSelection(unitId, subUnitId, range);
  }, [sheetsSortUIService, range, subUnitId, unitId]);
  useEffect(() => {
    listEndRef.current && list.length > 5 && (listEndRef.current.scrollTop = listEndRef.current.scrollHeight);
  }, [list]);
  const canNew = list.length < titles.length, dragList = list.map((item) => ({ ...item, id: `${item.colIndex}` }));
  return /* @__PURE__ */ React.createElement("div", { className: styles.customSortPanelContainer }, /* @__PURE__ */ React.createElement("div", { className: styles.customSortPanelContent, onMouseDown: /* @__PURE__ */ __name((e) => {
    e.stopPropagation();
  }, "onMouseDown") }, /* @__PURE__ */ React.createElement("div", { className: styles.customSortPanelExt }, /* @__PURE__ */ React.createElement("div", { className: styles.firstRowCheck }, /* @__PURE__ */ React.createElement(Checkbox, { checked: hasTitle, onChange: /* @__PURE__ */ __name((value) => setTitle(!!value), "onChange") }, localeService.t("sheets-sort.dialog.first-row-check"))), canNew ? /* @__PURE__ */ React.createElement("div", { className: styles.addCondition, onClick: newItem }, /* @__PURE__ */ React.createElement(IncreaseSingle, null), /* @__PURE__ */ React.createElement("span", { className: styles.addConditionText }, localeService.t("sheets-sort.dialog.add-condition"))) : /* @__PURE__ */ React.createElement("div", { className: `${styles.addCondition} ${styles.addConditionDisable}` }, /* @__PURE__ */ React.createElement(IncreaseSingle, null), /* @__PURE__ */ React.createElement("span", { className: styles.addConditionText }, localeService.t("sheets-sort.dialog.add-condition")))), /* @__PURE__ */ React.createElement(
    "div",
    {
      className: styles.conditionList,
      onScroll: /* @__PURE__ */ __name((e) => {
        const position = e.currentTarget.scrollTop;
        setScrollPosition(position);
      }, "onScroll"),
      ref: listEndRef
    },
    /* @__PURE__ */ React.createElement(
      DraggableList,
      {
        list: dragList,
        onListChange: setList,
        idKey: "id",
        draggableHandle: `.${styles.customSortPanelItemHandler}`,
        itemRender: /* @__PURE__ */ __name((item) => /* @__PURE__ */ React.createElement(
          SortOptionItem,
          {
            titles,
            list: dragList,
            item,
            onChange: /* @__PURE__ */ __name((value, index) => onItemChange(index, value), "onChange"),
            scrollPosition
          }
        ), "itemRender"),
        rowHeight: 32,
        margin: [0, 12]
      }
    )
  )), /* @__PURE__ */ React.createElement("div", { className: styles.customSortPanelFooter }, /* @__PURE__ */ React.createElement(Button, { className: styles.customSortPanelFooterBtn, type: "default", onClick: /* @__PURE__ */ __name(() => cancel(), "onClick") }, localeService.t("sheets-sort.dialog.cancel")), /* @__PURE__ */ React.createElement(Button, { className: styles.customSortPanelFooterBtn, type: "primary", onClick: /* @__PURE__ */ __name(() => apply(list, hasTitle), "onClick") }, localeService.t("sheets-sort.dialog.confirm"))));
}
__name(CustomSortPanel, "CustomSortPanel");
function SortOptionItem(props) {
  var _a4;
  const { list, item, titles, onChange, scrollPosition } = props, localeService = useDependency(LocaleService), availableMenu = titles.filter((title) => !list.some((item2) => item2.colIndex === title.index) || title.index === item.colIndex), currentIndex = list.findIndex((listItem) => listItem.colIndex === item.colIndex), handleChangeColIndex = useCallback((menuItem) => {
    onChange({ ...item, colIndex: menuItem.index }, currentIndex), setVisible(!1);
  }, [currentIndex, item, onChange]), [visible, setVisible] = useState(!1), onVisibleChange = /* @__PURE__ */ __name((visible2) => {
    setVisible(visible2);
  }, "onVisibleChange");
  useEffect(() => {
    setVisible(!1);
  }, [scrollPosition]);
  const showDelete = list.length > 1, itemLabel = (_a4 = titles.find((title) => title.index === item.colIndex)) == null ? void 0 : _a4.label, radioClass = localeService.getCurrentLocale() === LocaleType.ZH_CN ? styles.customSortPanelItemOrderRadioCn : styles.customSortPanelItemOrderRadio;
  return /* @__PURE__ */ React.createElement("div", { className: styles.customSortPanelItem }, /* @__PURE__ */ React.createElement("div", { className: styles.customSortPanelItemHead }, /* @__PURE__ */ React.createElement("div", { className: styles.customSortPanelItemHandler }, /* @__PURE__ */ React.createElement(SequenceSingle, null)), /* @__PURE__ */ React.createElement("div", { className: styles.customSortPanelItemColumn }, /* @__PURE__ */ React.createElement(
    Dropdown,
    {
      placement: "bottomLeft",
      trigger: ["click"],
      visible,
      onVisibleChange,
      overlay: /* @__PURE__ */ React.createElement("ul", { className: styles.customSortColMenu }, availableMenu.map((menuItem) => /* @__PURE__ */ React.createElement(
        "li",
        {
          key: menuItem.index,
          onClick: /* @__PURE__ */ __name(() => handleChangeColIndex(menuItem), "onClick"),
          className: styles.customSortColMenuItem
        },
        /* @__PURE__ */ React.createElement("span", { className: styles.customSortColMenuItemDesc }, menuItem.label),
        /* @__PURE__ */ React.createElement("span", { className: styles.customSortColMenuItemCheck }, menuItem.index === item.colIndex && /* @__PURE__ */ React.createElement(CheckMarkSingle, null))
      )))
    },
    /* @__PURE__ */ React.createElement("div", { className: styles.customSortPanelItemColumnInput }, /* @__PURE__ */ React.createElement("span", { className: styles.customSortPanelItemColumnInputText }, itemLabel), /* @__PURE__ */ React.createElement(MoreDownSingle, { className: styles.customSortPanelItemColumnInputDropdown }))
  ))), /* @__PURE__ */ React.createElement("div", { className: styles.customSortPanelItemOrder }, /* @__PURE__ */ React.createElement(
    RadioGroup,
    {
      className: radioClass,
      value: item.type,
      onChange: /* @__PURE__ */ __name((value) => {
        onChange({ ...item, type: value }, currentIndex);
      }, "onChange")
    },
    /* @__PURE__ */ React.createElement(Radio, { value: SortType.ASC }, localeService.t("sheets-sort.general.sort-asc")),
    /* @__PURE__ */ React.createElement(Radio, { value: SortType.DESC }, localeService.t("sheets-sort.general.sort-desc"))
  )), /* @__PURE__ */ React.createElement("div", { className: styles.customSortPanelItemRemove }, showDelete && /* @__PURE__ */ React.createElement(DeleteEmptySingle, { onClick: /* @__PURE__ */ __name(() => onChange(null, currentIndex), "onClick") })));
}
__name(SortOptionItem, "SortOptionItem");
function findNextColIndex(range, list) {
  const { startColumn, endColumn } = range, used = new Set(list.map((item) => item == null ? void 0 : item.colIndex));
  for (let i = startColumn; i <= endColumn; i++)
    if (!used.has(i))
      return i;
  return null;
}
__name(findNextColIndex, "findNextColIndex");
function EmbedSortBtn(props) {
  const { range, colIndex, onClose } = props, sheetsSortUIService = useDependency(SheetsSortUIService), univerInstanceService = useDependency(IUniverInstanceService), localeService = useDependency(LocaleService), apply = useCallback((asc) => {
    const { unitId, subUnitId } = getSheetCommandTarget(univerInstanceService) || {};
    if (range && unitId && subUnitId) {
      const noTitleRange = { ...range, startRow: range.startRow + 1 };
      sheetsSortUIService.triggerSortDirectly(asc, !1, { unitId, subUnitId, range: noTitleRange, colIndex });
    } else
      console.warn(`Cannot find the target to sort. unitId: ${unitId}, subUnitId: ${subUnitId}, range: ${range}, colIndex: ${colIndex}`);
    onClose();
  }, [range, colIndex, sheetsSortUIService, univerInstanceService, onClose]);
  return /* @__PURE__ */ React.createElement("div", { className: styles.embedSortBtnContainer }, /* @__PURE__ */ React.createElement("div", { className: `${styles.embedSortBtn} ${styles.embedSortBtnAsc}`, onClick: /* @__PURE__ */ __name(() => apply(!0), "onClick") }, /* @__PURE__ */ React.createElement(AscendingSingle, { className: styles.embedSortBtnIcon }), localeService.t("sheets-sort.general.sort-asc")), /* @__PURE__ */ React.createElement("div", { className: `${styles.embedSortBtn} ${styles.embedSortBtnDesc}`, onClick: /* @__PURE__ */ __name(() => apply(!1), "onClick") }, /* @__PURE__ */ React.createElement(DescendingSingle, { className: styles.embedSortBtnIcon }), localeService.t("sheets-sort.general.sort-desc")));
}
__name(EmbedSortBtn, "EmbedSortBtn");
const SHEETS_SORT_MENU_ID = "sheet.menu.sheets-sort", SHEETS_SORT_CTX_MENU_ID = "sheet.menu.sheets-sort-ctx", SHEETS_SORT_ASC_ICON = "AscendingSingle", SHEETS_SORT_ASC_EXT_ICON = "ExpandAscendingSingle", SHEETS_SORT_DESC_ICON = "DescendingSingle", SHEETS_SORT_DESC_EXT_ICON = "ExpandDescendingSingle", SHEETS_SORT_CUSTOM_ICON = "CustomSortSingle";
function sortRangeMenuFactory(accessor) {
  return {
    id: SHEETS_SORT_MENU_ID,
    type: MenuItemType.SUBITEMS,
    icon: SHEETS_SORT_ASC_ICON,
    tooltip: "sheets-sort.general.sort",
    hidden$: getMenuHiddenObservable(accessor, UniverInstanceType.UNIVER_SHEET),
    disabled$: getCurrentRangeDisable$(accessor, { workbookTypes: [WorkbookEditablePermission], worksheetTypes: [WorksheetSortPermission, WorksheetEditPermission], rangeTypes: [RangeProtectionPermissionEditPoint] })
  };
}
__name(sortRangeMenuFactory, "sortRangeMenuFactory");
function sortRangeAscMenuFactory(_accessor) {
  return {
    id: SortRangeAscCommand.id,
    icon: SHEETS_SORT_ASC_ICON,
    title: "sheets-sort.general.sort-asc-cur",
    type: MenuItemType.BUTTON,
    hidden$: getCurrentExclusiveRangeInterest$(_accessor)
  };
}
__name(sortRangeAscMenuFactory, "sortRangeAscMenuFactory");
function sortRangeAscExtMenuFactory(_accessor) {
  return {
    id: SortRangeAscExtCommand.id,
    title: "sheets-sort.general.sort-asc-ext",
    icon: SHEETS_SORT_ASC_EXT_ICON,
    type: MenuItemType.BUTTON
  };
}
__name(sortRangeAscExtMenuFactory, "sortRangeAscExtMenuFactory");
function sortRangeDescMenuFactory(_accessor) {
  return {
    id: SortRangeDescCommand.id,
    title: "sheets-sort.general.sort-desc-cur",
    icon: SHEETS_SORT_DESC_ICON,
    type: MenuItemType.BUTTON
  };
}
__name(sortRangeDescMenuFactory, "sortRangeDescMenuFactory");
function sortRangeDescExtMenuFactory(_accessor) {
  return {
    id: SortRangeDescExtCommand.id,
    title: "sheets-sort.general.sort-desc-ext",
    icon: SHEETS_SORT_DESC_EXT_ICON,
    type: MenuItemType.BUTTON
  };
}
__name(sortRangeDescExtMenuFactory, "sortRangeDescExtMenuFactory");
function sortRangeCustomMenuFactory(_accessor) {
  return {
    id: SortRangeCustomCommand.id,
    title: "sheets-sort.general.sort-custom",
    type: MenuItemType.BUTTON,
    icon: SHEETS_SORT_CUSTOM_ICON
  };
}
__name(sortRangeCustomMenuFactory, "sortRangeCustomMenuFactory");
function sortRangeCtxMenuFactory(accessor) {
  return {
    id: SHEETS_SORT_CTX_MENU_ID,
    title: "sheets-sort.general.sort",
    type: MenuItemType.SUBITEMS,
    icon: SHEETS_SORT_ASC_ICON,
    hidden$: getMenuHiddenObservable(accessor, UniverInstanceType.UNIVER_SHEET),
    disabled$: getCurrentRangeDisable$(accessor, {
      workbookTypes: [WorkbookEditablePermission],
      worksheetTypes: [WorksheetSortPermission, WorksheetEditPermission],
      rangeTypes: [RangeProtectionPermissionEditPoint]
    })
  };
}
__name(sortRangeCtxMenuFactory, "sortRangeCtxMenuFactory");
function sortRangeAscCtxMenuFactory(_accessor) {
  return {
    id: SortRangeAscInCtxMenuCommand.id,
    title: "sheets-sort.general.sort-asc-cur",
    type: MenuItemType.BUTTON,
    icon: SHEETS_SORT_ASC_ICON,
    disabled$: getCurrentRangeDisable$(_accessor, { workbookTypes: [WorkbookEditablePermission], worksheetTypes: [WorksheetSortPermission, WorksheetEditPermission], rangeTypes: [RangeProtectionPermissionEditPoint] })
  };
}
__name(sortRangeAscCtxMenuFactory, "sortRangeAscCtxMenuFactory");
function sortRangeAscExtCtxMenuFactory(_accessor) {
  return {
    id: SortRangeAscExtInCtxMenuCommand.id,
    title: "sheets-sort.general.sort-asc-ext",
    type: MenuItemType.BUTTON,
    icon: SHEETS_SORT_ASC_EXT_ICON,
    disabled$: getCurrentRangeDisable$(_accessor, { workbookTypes: [WorkbookEditablePermission], worksheetTypes: [WorksheetSortPermission, WorksheetEditPermission], rangeTypes: [RangeProtectionPermissionEditPoint] })
  };
}
__name(sortRangeAscExtCtxMenuFactory, "sortRangeAscExtCtxMenuFactory");
function sortRangeDescCtxMenuFactory(_accessor) {
  return {
    id: SortRangeDescInCtxMenuCommand.id,
    title: "sheets-sort.general.sort-desc-cur",
    type: MenuItemType.BUTTON,
    icon: SHEETS_SORT_DESC_ICON,
    disabled$: getCurrentRangeDisable$(_accessor, { workbookTypes: [WorkbookEditablePermission], worksheetTypes: [WorksheetSortPermission, WorksheetEditPermission], rangeTypes: [RangeProtectionPermissionEditPoint] })
  };
}
__name(sortRangeDescCtxMenuFactory, "sortRangeDescCtxMenuFactory");
function sortRangeDescExtCtxMenuFactory(_accessor) {
  return {
    id: SortRangeDescExtInCtxMenuCommand.id,
    title: "sheets-sort.general.sort-desc-ext",
    type: MenuItemType.BUTTON,
    icon: SHEETS_SORT_DESC_EXT_ICON,
    disabled$: getCurrentRangeDisable$(_accessor, { workbookTypes: [WorkbookEditablePermission], worksheetTypes: [WorksheetSortPermission, WorksheetEditPermission], rangeTypes: [RangeProtectionPermissionEditPoint] })
  };
}
__name(sortRangeDescExtCtxMenuFactory, "sortRangeDescExtCtxMenuFactory");
function sortRangeCustomCtxMenuFactory(_accessor) {
  return {
    id: SortRangeCustomInCtxMenuCommand.id,
    title: "sheets-sort.general.sort-custom",
    type: MenuItemType.BUTTON,
    icon: SHEETS_SORT_CUSTOM_ICON,
    disabled$: getCurrentRangeDisable$(_accessor, { workbookTypes: [WorkbookEditablePermission], worksheetTypes: [WorksheetSortPermission, WorksheetEditPermission], rangeTypes: [RangeProtectionPermissionEditPoint] })
  };
}
__name(sortRangeCustomCtxMenuFactory, "sortRangeCustomCtxMenuFactory");
const menuSchema = {
  [RibbonStartGroup.FORMULAS_INSERT]: {
    [SHEETS_SORT_MENU_ID]: {
      order: 2,
      menuItemFactory: sortRangeMenuFactory,
      [SortRangeAscCommand.id]: {
        order: 0,
        menuItemFactory: sortRangeAscMenuFactory
      },
      [SortRangeAscExtCommand.id]: {
        order: 1,
        menuItemFactory: sortRangeAscExtMenuFactory
      },
      [SortRangeDescCommand.id]: {
        order: 2,
        menuItemFactory: sortRangeDescMenuFactory
      },
      [SortRangeDescExtCommand.id]: {
        order: 3,
        menuItemFactory: sortRangeDescExtMenuFactory
      },
      [SortRangeCustomCommand.id]: {
        order: 4,
        menuItemFactory: sortRangeCustomMenuFactory
      }
    }
  },
  [ContextMenuPosition.MAIN_AREA]: {
    [ContextMenuGroup.DATA]: {
      [SHEETS_SORT_CTX_MENU_ID]: {
        order: 0,
        menuItemFactory: sortRangeCtxMenuFactory,
        [SortRangeAscInCtxMenuCommand.id]: {
          order: 0,
          menuItemFactory: sortRangeAscCtxMenuFactory
        },
        [SortRangeAscExtInCtxMenuCommand.id]: {
          order: 1,
          menuItemFactory: sortRangeAscExtCtxMenuFactory
        },
        [SortRangeDescInCtxMenuCommand.id]: {
          order: 2,
          menuItemFactory: sortRangeDescCtxMenuFactory
        },
        [SortRangeDescExtInCtxMenuCommand.id]: {
          order: 3,
          menuItemFactory: sortRangeDescExtCtxMenuFactory
        },
        [SortRangeCustomInCtxMenuCommand.id]: {
          order: 4,
          menuItemFactory: sortRangeCustomCtxMenuFactory
        }
      }
    }
  }
};
var __defProp$1 = Object.defineProperty, __getOwnPropDesc$1 = Object.getOwnPropertyDescriptor, __decorateClass$1 = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc$1(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp$1(target, key, result), result;
}, "__decorateClass$1"), __decorateParam$1 = /* @__PURE__ */ __name((index, decorator) => (target, key) => decorator(target, key, index), "__decorateParam$1");
const CUSTOM_SORT_DIALOG_ID = "custom-sort-dialog", CUSTOM_SORT_PANEL_WIDTH = 560;
var _a2;
let SheetsSortUIController = (_a2 = class extends RxDisposable {
  constructor(_commandService, _menuManagerService, _dialogService, _layoutService, _uiPartsService, _sheetRenderService, _localeService, _sheetsSortUIService, _injector, _componentManager) {
    super(), this._commandService = _commandService, this._menuManagerService = _menuManagerService, this._dialogService = _dialogService, this._layoutService = _layoutService, this._uiPartsService = _uiPartsService, this._sheetRenderService = _sheetRenderService, this._localeService = _localeService, this._sheetsSortUIService = _sheetsSortUIService, this._injector = _injector, this._componentManager = _componentManager, this._initCommands(), this._initMenu(), this._initUI();
  }
  _initMenu() {
    this._menuManagerService.mergeMenu(menuSchema);
  }
  _initCommands() {
    [
      SortRangeAscCommand,
      SortRangeAscExtCommand,
      SortRangeDescCommand,
      SortRangeDescExtCommand,
      SortRangeCustomCommand,
      SortRangeAscInCtxMenuCommand,
      SortRangeAscExtInCtxMenuCommand,
      SortRangeDescInCtxMenuCommand,
      SortRangeDescExtInCtxMenuCommand,
      SortRangeCustomInCtxMenuCommand
    ].forEach((command) => this.disposeWithMe(this._commandService.registerCommand(command))), this.disposeWithMe(this._sheetRenderService.registerSkeletonChangingMutations(SortRangeCommand.id));
  }
  _initUI() {
    this.disposeWithMe(this._componentManager.register("CustomSortPanel", CustomSortPanel)), this.disposeWithMe(this._uiPartsService.registerComponent(SheetsUIPart.FILTER_PANEL_EMBED_POINT, () => connectInjector(EmbedSortBtn, this._injector))), this.disposeWithMe(this._componentManager.register(SHEETS_SORT_ASC_ICON, AscendingSingle)), this.disposeWithMe(this._componentManager.register(SHEETS_SORT_ASC_EXT_ICON, ExpandAscendingSingle)), this.disposeWithMe(this._componentManager.register(SHEETS_SORT_DESC_ICON, DescendingSingle)), this.disposeWithMe(this._componentManager.register(SHEETS_SORT_DESC_EXT_ICON, ExpandDescendingSingle)), this.disposeWithMe(this._componentManager.register(SHEETS_SORT_CUSTOM_ICON, CustomSortSingle)), this._sheetsSortUIService.customSortState$.pipe(takeUntil(this.dispose$)).subscribe((newState) => {
      newState && newState.show && newState.location ? this._openCustomSortPanel(newState.location) : newState && !(newState != null && newState.show) && this._closePanel();
    });
  }
  _openCustomSortPanel(location) {
    this._dialogService.open({
      id: CUSTOM_SORT_DIALOG_ID,
      draggable: !0,
      width: CUSTOM_SORT_PANEL_WIDTH,
      title: { title: `${this._localeService.t("sheets-sort.general.sort-custom")}: ${serializeRange(location.range)}` },
      children: { label: "CustomSortPanel" },
      destroyOnClose: !0,
      defaultPosition: getCustomSortDialogDefaultPosition(),
      preservePositionOnDestroy: !1,
      onClose: /* @__PURE__ */ __name(() => this._closePanel(), "onClose"),
      mask: !0
    });
  }
  _closePanel() {
    this._dialogService.close(CUSTOM_SORT_DIALOG_ID), queueMicrotask(() => this._layoutService.focus());
  }
}, __name(_a2, "SheetsSortUIController"), _a2);
SheetsSortUIController = __decorateClass$1([
  __decorateParam$1(0, ICommandService),
  __decorateParam$1(1, IMenuManagerService),
  __decorateParam$1(2, IDialogService),
  __decorateParam$1(3, ILayoutService),
  __decorateParam$1(4, IUIPartsService),
  __decorateParam$1(5, Inject(SheetsRenderService)),
  __decorateParam$1(6, Inject(LocaleService)),
  __decorateParam$1(7, Inject(SheetsSortUIService)),
  __decorateParam$1(8, Inject(Injector)),
  __decorateParam$1(9, Inject(ComponentManager))
], SheetsSortUIController);
function getCustomSortDialogDefaultPosition() {
  return { x: 0, y: 0 };
}
__name(getCustomSortDialogDefaultPosition, "getCustomSortDialogDefaultPosition");
var __defProp2 = Object.defineProperty, __getOwnPropDesc = Object.getOwnPropertyDescriptor, __defNormalProp2 = /* @__PURE__ */ __name((obj, key, value) => key in obj ? __defProp2(obj, key, { enumerable: !0, configurable: !0, writable: !0, value }) : obj[key] = value, "__defNormalProp"), __decorateClass = /* @__PURE__ */ __name((decorators, target, key, kind) => {
  for (var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target, i = decorators.length - 1, decorator; i >= 0; i--)
    (decorator = decorators[i]) && (result = (kind ? decorator(target, key, result) : decorator(result)) || result);
  return kind && result && __defProp2(target, key, result), result;
}, "__decorateClass"), __decorateParam = /* @__PURE__ */ __name((index, decorator) => (target, key) => decorator(target, key, index), "__decorateParam"), __publicField2 = /* @__PURE__ */ __name((obj, key, value) => __defNormalProp2(obj, typeof key != "symbol" ? key + "" : key, value), "__publicField");
const NAME = "SHEET_SORT_UI_PLUGIN";
var _a3;
let UniverSheetsSortUIPlugin = (_a3 = class extends Plugin {
  constructor(_config = defaultPluginConfig, _injector, _configService) {
    super(), this._config = _config, this._injector = _injector, this._configService = _configService;
    const { ...rest } = this._config;
    this._configService.setConfig(PLUGIN_CONFIG_KEY, rest);
  }
  onStarting() {
    [
      [SheetsSortUIService],
      [SheetsSortUIController]
    ].forEach((d) => this._injector.add(d));
  }
  onRendered() {
    this._injector.get(SheetsSortUIController);
  }
}, __name(_a3, "UniverSheetsSortUIPlugin"), _a3);
__publicField2(UniverSheetsSortUIPlugin, "type", UniverInstanceType.UNIVER_SHEET);
__publicField2(UniverSheetsSortUIPlugin, "pluginName", NAME);
UniverSheetsSortUIPlugin = __decorateClass([
  DependentOn(UniverSheetsSortPlugin),
  __decorateParam(1, Inject(Injector)),
  __decorateParam(2, IConfigService)
], UniverSheetsSortUIPlugin);
export {
  SortRangeAscCommand,
  SortRangeAscExtCommand,
  SortRangeAscExtInCtxMenuCommand,
  SortRangeAscInCtxMenuCommand,
  SortRangeCustomCommand,
  SortRangeCustomInCtxMenuCommand,
  SortRangeDescCommand,
  SortRangeDescExtCommand,
  SortRangeDescExtInCtxMenuCommand,
  SortRangeDescInCtxMenuCommand,
  UniverSheetsSortUIPlugin
};
